Добавил:
Опубликованный материал нарушает ваши авторские права? Сообщите нам.
Вуз: Предмет: Файл:
Cooper M.Advanced bash-scripting guide.2002.pdf
Скачиваний:
13
Добавлен:
23.08.2013
Размер:
916.67 Кб
Скачать

Chapter 24. Aliases

A Bash alias is essentially nothing more than a keyboard shortcut, an abbreviation, a means of avoiding typing a long command sequence. If, for example, we include alias lm="ls −l | more" in the

~/.bashrc file, then each lm typed at the command line will automatically be replaced by a ls −l | more. This can save a great deal of typing at the command line and avoid having to remember complex combinations of commands and options. Setting alias rm="rm −i" (interactive mode delete) may save a good deal of grief, since it can prevent inadvertently losing important files.

In a script, aliases have very limited usefulness. It would be quite nice if aliases could assume some of the functionality of the C preprocessor, such as macro expansion, but unfortunately Bash does not expand arguments within the alias body. [54] Moreover, a script fails to expand an alias itself within "compound constructs", such as if/then statements, loops, and functions. An added limitation is that an alias will not expand recursively. Almost invariably, whatever we would like an alias to do could be accomplished much more effectively with a function.

Example 24−1. Aliases within a script

#!/bin/bash

# May need to be invoked with #!/bin/bash2 on older systems.

shopt −s expand_aliases

#Must set this option, else script will not expand aliases.

#First, some fun.

alias Jesse_James='echo "\"Alias Jesse James\" was a 1959 comedy starring Bob Hope."' Jesse_James

echo; echo; echo;

alias ll="ls −l"

# May use either single (') or double (") quotes to define an alias.

echo "Trying aliased \"ll\":"

ll /usr/X11R6/bin/mk*

#* Alias works.

echo

 

directory=/usr/X11R6/bin/

prefix=mk* # See if wild−card causes problems.

echo "Variables \"directory\" + \"prefix\" = $directory$prefix" echo

alias lll="ls −l $directory$prefix"

echo "Trying aliased \"lll\":"

lll # Long listing of all files in /usr/X11R6/bin stating with mk.

# Alias handles concatenated variables, including wild−card o.k.

TRUE=1

Chapter 24. Aliases

257

Advanced Bash−Scripting Guide

echo

if [ TRUE ] then

alias rr="ls −l"

echo "Trying aliased \"rr\" within if/then statement:" rr /usr/X11R6/bin/mk* #* Error message results!

# Aliases not expanded within compound statements.

echo "However, previously expanded alias still recognized:" ll /usr/X11R6/bin/mk*

fi

echo

count=0

while [ $count −lt 3 ] do

alias rrr="ls −l"

echo "Trying aliased \"rrr\" within \"while\" loop:"

rrr

/usr/X11R6/bin/mk* #* Alias will not expand here either.

let

count+=1

done

 

echo;

echo

alias

xyz="cat $1" # Try a positional parameter in an alias.

xyz

# If you invoke the script with a filename as a parameter.

#This seems to work,

#+ although the Bash documentation suggests that it shouldn't.

exit 0

The unalias command removes a previously set alias.

Example 24−2. unalias: Setting and unsetting an alias

#!/bin/bash

shopt −s expand_aliases # Enables alias expansion.

alias llm='ls −al | more' llm

echo

 

 

 

 

 

 

 

unalias llm

 

 

# Unset alias.

 

 

 

llm

 

 

 

 

 

 

 

# Error message results, since 'llm' no longer recognized.

exit 0

 

 

 

 

 

 

 

bash$ ./unalias.sh

 

 

 

 

 

total 6

 

 

 

 

 

 

 

drwxrwxr−x

2

bozo

bozo

3072

Feb

6

14:04 .

drwxr−xr−x

40

bozo

bozo

2048

Feb

6

14:04 ..

−rwxr−xr−x

1

bozo

bozo

199

Feb

6

14:04 unalias.sh

./unalias.sh: llm: command not found

Chapter 24. Aliases

258

Advanced Bash−Scripting Guide

Chapter 24. Aliases

259

Chapter 25. List Constructs

The "and list" and "or list" constructs provide a means of processing a number of commands consecutively. These can effectively replace complex nested if/then or even case statements.

Chaining together commands

and list

command−1 && command−2 && command−3 && ... command−n

Each command executes in turn provided that the previous command has given a return value of true (zero). At the first false (non−zero) return, the command chain terminates (the first command returning false is the last one to execute).

Example 25−1. Using an "and list" to test for command−line arguments

#!/bin/bash

# "and list"

if [ ! −z "$1" ] && echo "Argument #1 = $1" && [ ! −z "$2" ] && echo "Argument #2 = $2" then

echo "At least 2 arguments passed to script."

#All the chained commands return true.

else

echo "Less than 2 arguments passed to script."

#At least one of the chained commands returns false.

fi

#Note that "if [ ! −z $1 ]" works, but its supposed equivalent,

#if [ −n $1 ] does not. However, quoting fixes this.

#if [ −n "$1" ] works. Careful!

#It is best to always quote tested variables.

#This accomplishes the same thing, using "pure" if/then statements. if [ ! −z "$1" ]

then

echo "Argument #1 = $1"

fi

if [ ! −z "$2" ] then

echo "Argument #2 = $2"

echo "At least 2 arguments passed to script." else

echo "Less than 2 arguments passed to script."

fi

#It's longer and less elegant than using an "and list".

exit 0

Example 25−2. Another command−line arg test using an "and list"

#!/bin/bash

ARGS=1

# Number of arguments expected.

Chapter 25. List Constructs

260

Advanced Bash−Scripting Guide

E_BADARGS=65 # Exit value if incorrect number of args passed.

test $# −ne $ARGS && echo "Usage: `basename $0` $ARGS argument(s)" && exit $E_BADARGS

#If condition−1 true (wrong number of args passed to script),

#then the rest of the line executes, and script terminates.

#Line below executes only if the above test fails.

echo "Correct number of arguments passed to this script."

exit 0

# To check exit value, do a "echo $?" after script termination.

or list

command−1 || command−2 || command−3 || ... command−n

Each command executes in turn for as long as the previous command returns false. At the first true return, the command chain terminates (the first command returning true is the last one to execute). This is obviously the inverse of the "and list".

Example 25−3. Using "or lists" in combination with an "and list"

#!/bin/bash

#"Delete", not−so−cunning file deletion utility.

#Usage: delete filename

E_BADARGS=65

if [ −z "$1" ] then

echo "Usage: `basename $0` filename" exit $E_BADARGS

fi

file=$1 # Set filename.

[ ! −f "$1" ] && echo "File \"$1\" not found. \ Cowardly refusing to delete a nonexistent file."

#AND LIST, to give error message if file not present.

#Note echo message continued on to a second line with an escape.

[ ! −f "$1" ] || (rm −f $1; echo "File \"$file\" deleted.")

#OR LIST, to delete file if present.

#( command1 ; command2 ) is, in effect, an AND LIST variant.

#Note logic inversion above.

#AND LIST executes on true, OR LIST on false.

exit 0

If the first command in an "or list" returns true, it will execute.

The exit status of an and list or an or list is the exit status of the last command executed.

Chapter 25. List Constructs

261

Advanced Bash−Scripting Guide

Clever combinations of "and" and "or" lists are possible, but the logic may easily become convoluted and require extensive debugging.

false

&& true || echo false

# false

# Same result as

 

 

(

false && true ) || echo false

#

false

#

But

*not*

 

 

false

&& ( true || echo false )

#

(nothing echoed)

#Note left−to−right grouping and evaluation of statements,

#since the logic operators "&&" and "||" have equal precedence.

#It's best to avoid such complexities, unless you know what you're doing.

#Thanks, S.C.

See Example A−6 for an illustration of using an and / or list to test variables.

Chapter 25. List Constructs

262